unit Twitter_OLogin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, mshtml;

type
  TTwitterLogin = class(TForm)
    TwitterLoginPage: TWebBrowser;
    procedure TwitterLoginPageBeforeNavigate2(ASender: TObject;
      const pDisp: IDispatch; const URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure TwitterLoginPageDocumentComplete(ASender: TObject;
      const pDisp: IDispatch; const URL: OleVariant);
  private
    { Private declarations }
  public
    UserName: string;
    PIN: string;
    ValidURL: string;
  end;

var
  TwitterLogin: TTwitterLogin;

implementation

{$R *.dfm}

////////////////////////////////////////////////////////////////////////////////
// FORM METHODS                                                               //
////////////////////////////////////////////////////////////////////////////////

procedure TTwitterLogin.TwitterLoginPageBeforeNavigate2(ASender: TObject;
  const pDisp: IDispatch; const URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
begin
  if ValidURL <> TwitterLoginPage.LocationURL then ModalResult := mrOK;
end;

procedure TTwitterLogin.TwitterLoginPageDocumentComplete(ASender: TObject;
  const pDisp: IDispatch; const URL: OleVariant);
var
  doc: IHTMLDocument3;
  elm: IHTMLElement;
  list: IHTMLElementCollection;
begin
  doc := (pDisp as IWebBrowser).Document as IHTMLDocument3;
  elm := doc.getElementById('username_or_email');
  if elm <> nil then
  begin
    (elm as IHTMLInputElement).value := UserName;
    elm := doc.getElementById('password');
    if elm <> nil then
    begin
      (elm as IHTMLElement2).focus;
    end;
  end
  else begin
    elm := doc.getElementById('oauth_pin');
    if elm <> nil then
    begin
      list := (elm as IHTMLElement2).getElementsByTagName('code');
      if list.length > 0 then
      begin
        PIN := (list.item(0, EmptyParam) as IHTMLElement).innerText;
        Close;
      end;
    end;
  end;
end;

end.
